 .586
 .model flat, c

 INCLUDE asmtime.inc


 .code

getCPUstring PROC
    push eax
    push ebx
    push ecx
    push edx
    push edi
    lea  edi, idString1
    mov  eax, 0
    CPUID
    mov[edi],   ebx
    mov[edi+4], edx
    mov[edi+8], ecx
    mov ecx, 0
    mov[edi+12], ecx
    pop edi
    pop edx
    pop ecx
    pop ebx
    pop eax
    ret
getCPUstring ENDP


getCPUDetails PROC
        push eax
        push ebx
        push ecx
        push edx
        push edi
        mov  eax, 1
        CPUID
        mov DWORD PTR eaxCode1, eax  ; Features Code
        mov DWORD PTR edxCode1, edx  ; family/model/stepping
        mov DWORD PTR ecxCode1, ecx 
        mov DWORD PTR ebxCode1, ebx 

        ; get specials
        mov eax,80000000h
        CPUID
        cmp eax,80000000h
        jc nomore
        mov eax, DWORD PTR intel1amd2
        cmp eax, 1
        jz intel
        cmp eax, 2
        jnz nomore
        mov eax,80000001h
        CPUID
        mov DWORD PTR ext81edx,edx
        mov eax,80000000h
        CPUID
        cmp eax,80000004h
        jc nomore                
        lea  edi, idString2
        mov eax,80000002h
        CPUID
        mov[edi],    eax
        mov[edi+4],  ebx
        mov[edi+8],  ecx
        mov[edi+12], edx
        mov eax,80000003h
        CPUID
        mov[edi+16], eax
        mov[edi+20], ebx
        mov[edi+24], ecx
        mov[edi+28], edx
        mov eax,80000004h
        CPUID
        mov[edi+32], eax
        mov[edi+36], ebx
        mov[edi+40], ecx
        mov[edi+44], edx
        mov ecx, 0
        mov[edi+48], ecx
        jmp nomore
     intel:
        mov eax,80000000h
        CPUID
        cmp eax,80000004h
        jc nomore                
        lea  edi, idString2
        mov eax,80000002h
        CPUID
        mov[edi],    eax
        mov[edi+4],  ebx
        mov[edi+8],  ecx
        mov[edi+12], edx
        mov eax,80000003h
        CPUID
        mov[edi+16], eax
        mov[edi+20], ebx
        mov[edi+24], ecx
        mov[edi+28], edx
        mov eax,80000004h
        CPUID
        mov[edi+32], eax
        mov[edi+36], ebx
        mov[edi+40], ecx
        mov[edi+44], edx
        mov ecx, 0
        mov[edi+48], ecx
     nomore:
        pop edi
        pop edx
        pop ecx
        pop ebx
        pop eax
        ret
getCPUDetails ENDP

calculateMHz PROC
        push eax
        push edx
        mov DWORD PTR startCount, 0
        mov DWORD PTR endCount, 0
        call start_time
        RDTSC 
        mov DWORD PTR startCount, eax 
    timeloop:
        call end_time
        mov eax, DWORD PTR millisecs 
        cmp eax, DWORD PTR looptime
        jae      endloop
        mov edx, 1000
    mainloop:    
        dec     edx
        jne     mainloop
        RDTSC
        mov     DWORD PTR endCount, eax
        jmp     timeloop
    endloop:
        mov     eax, DWORD PTR endCount
        sub     eax, DWORD PTR startCount
        mov     DWORD PTR cycleCount, eax        
        pop edx
        pop eax
        ret
calculateMHz ENDP

end


