#include <windows.h>
#include <xmmintrin.h>

#define EXTRA_DATA_OFFSET   0
#define MENU_ABOUT          1
#define MENU_EXIT           9
#define MENU_RUNALL        11
#define MENU_SAVE          12


#define DATA_LIST         949
#define RUN_ALL           937
#define SAVE              933
#define EXIT_BUTTON       934

#ifdef __cplusplus
extern "C" {
#endif

void  mips1Reg(void);  // 1 32 bit integer
void  mips2Reg(void);
void  mips3Reg(void);
void  mips4Reg(void);

void  mipsa1Reg(void);  // 2 64 bit integer
void  mipsa2Reg(void);
void  mipsa3Reg(void);
void  mipsa4Reg(void);

void SSE1Reg(void);    // 5 32 bit SSE MFLOPS
void SSE2Reg(void);
void SSE3Reg(void);
void SSE4Reg(void);

void SSE21Reg(void);   // 6 64 bit SSE2 MFLOPS
void SSE22Reg(void);
void SSE23Reg(void);
void SSE24Reg(void);

void SSE2I1Reg(void);  // 3 SSE2 32 bit integer
void SSE2I2Reg(void);
void SSE2I3Reg(void);
void SSE2I4Reg(void);

void SSE2I1Reg2(void);  // 4 SSE2 64 bit integer
void SSE2I2Reg2(void);
void SSE2I3Reg2(void);
void SSE2I4Reg2(void);

void Now3D1Reg(void);
void Now3D2Reg(void);
void Now3D3Reg(void);
void Now3D4Reg(void);

extern unsigned int intCount;
extern unsigned int icount;
extern __int64 intCounta;
extern __int64 icounta;

extern double * dsum;
extern float  * ssum1;
extern int    * isum1;


#ifdef __cplusplus
};
#endif


